# -*- coding: utf-8 -*-

import random
import time
import sys

# ANSI escape sequences for text coloring
GREEN = '\033[92m'
MAGENTA = '\033[95m'
BLUE = '\033[94m'
YELLOW = '\033[93m'
RESET = '\033[0m'

def wrestling_match():
    global player_health, opponent_health
    global player_punches, player_kicks, player_body_slams
    global opponent_punches, opponent_kicks, opponent_body_slams
    global player_suplex
    global opponent_sharpshooter

    print("\n" * 10)
    print(BLUE + "===========================================")
    print("      Welcome to The Wrestling Arena!")
    print("===========================================" + RESET)
    ring_art = """
      ||-o=======================o-||
      ||-o=======================o-||
      ||-o=======================o-||
      |║                           ║| 
      |║                           ║|
       ║                           ║
       ║                           ║ 
       ║                           ║  
      ||-o=======================o-||
      ||-o=======================o-||
      ||-o=======================o-||
      ||---------------------------||
      ||                           ||
      ||___________________________|| """
    print ring_art
    print("\n" * 1)
    print(BLUE + "===========================================")
    print("      Welcome to The Wrestling Arena!")
    print("===========================================" + RESET)

    time.sleep(1)

    player_name = raw_input("Enter your name: ")
    print_slow("\nWelcome! Today's challenger is...")
    print_slow("\nthe best there is,\nthe best there was,\nthe best there ever will be...")
    print_slow("\n" * 3)
    print_slow(MAGENTA + " ♥  Bret Hart  ♥ " + RESET)
    print_slow("\n" * 3)
    print_slow("\nGet ready!\n" + RESET)

    player_health = 100
    opponent_health = 175

    player_punches = 10
    player_kicks = 5
    player_body_slams = 3
    player_suplex = 2

    opponent_punches = 12
    opponent_kicks = 7
    opponent_body_slams = 3
    opponent_sharpshooter = 1

    opponent_dazed = False

    while player_health > 0 and opponent_health > 0:
        print("===========================================" + RESET)
        print_slow(GREEN + player_name + "'s Health: " + str(player_health) + RESET + "\n")
        print_slow(MAGENTA + "Bret Hart's Health: " + str(opponent_health) + RESET + "\n")
        print("===========================================" + RESET + "\n")

        if player_health <= 30 and player_suplex > 0:
            print(YELLOW + "You can use your special move: suplex!" + RESET + "\n")

        if opponent_health <= 30 and opponent_sharpshooter > 0:
            print(YELLOW + "Bret Hart can use his special move: sharpshooter!" + RESET + "\n")

        if player_health > 0:
            if player_health <= 30:
                player_move = raw_input("Choose your move (punch, kick, body slam, suplex): ").lower()
                if player_move not in ['punch', 'kick', 'body slam', 'suplex']:
                    print("Invalid move. Choose punch, kick, body slam, or suplex.")
                    continue
            else:
                player_move = raw_input("Choose your move (punch, kick, body slam): ").lower()
                if player_move not in ['punch', 'kick', 'body slam']:
                    print("Invalid move. Choose punch, kick, or body slam.")
                    continue
        else:
            player_move = None

        if opponent_dazed:
            opponent_dazed = False

        if player_move == 'punch':
            if player_punches <= 0:
                print("You have no more punches left. Choose another move.")
                continue
            damage = random.randint(1, 15)
            print_slow(GREEN + player_name + " punches Bret Hart!" + RESET + "\n")
            print_slow(player_name + " dealt " + str(damage) + " damage." + RESET + "\n")
            opponent_health -= damage
            player_punches -= 1

            # Check if the opponent is dazed
            if random.random() < 0.5:
                opponent_dazed = True
                print(MAGENTA + "Bret Hart is dazed!" + RESET)

        elif player_move == 'kick':
            if player_kicks <= 0:
                print("You have no more kicks left. Choose another move.")
                continue
            damage = random.randint(5, 25)
            print_slow(GREEN + player_name + " kicks Bret Hart!" + RESET + "\n")
            print_slow(player_name + " dealt " + str(damage) + " damage." + RESET + "\n")
            opponent_health -= damage
            player_kicks -= 1

            # Check if the opponent is dazed
            if random.random() < 0.5:
                opponent_dazed = True
                print(MAGENTA + "Bret Hart is dazed!" + RESET)

        elif player_move == 'body slam':
            if player_body_slams <= 0:
                print("You have no more body slams left. Choose another move.")
                continue
            damage = random.randint(10, 40)
            print_slow(GREEN + player_name + " performs a body slam on Bret Hart!" + RESET + "\n")
            print_slow(player_name + " dealt " + str(damage) + " damage." + RESET + "\n")
            opponent_health -= damage
            player_body_slams -= 1

            # Check if the opponent is dazed
            if random.random() < 0.2:
                opponent_dazed = True
                print(MAGENTA + "Bret Hart is dazed!" + RESET)

        elif player_move == 'suplex':
            if player_health <= 30:
                if player_suplex <= 0:
                    print("You have no more special moves left. Choose another move.")
                    continue
                damage = random.randint(40, 60)
                print_slow(YELLOW + player_name + " executes a suplex on Bret Hart!" + RESET + "\n")
                print_slow(player_name + " dealt " + str(damage) + " damage." + RESET + "\n")
                opponent_health -= damage
                player_suplex -= 1
            else:
                print("Invalid move. Choose punch, kick, body slam, or suplex.")
                continue

        else:
            print("Invalid move. Choose punch, kick, body slam, or suplex.")
            continue

        if opponent_health <= 0:
            time.sleep(1)
            print("1...")
            time.sleep(1)
            print("2...")
            time.sleep(1)
            if opponent_health <= 0:
                if random.random() < (1 - player_health / 100.0):
                    print("3... The match is over!")
                    print_slow(GREEN + "Congratulations, " + player_name + "! You have pinned Bret Hart!" + RESET + "\n")
                    print("\n" * 1)
                    print(BLUE + "===========================================")
                    print(BLUE + player_name + " wins the match!" + RESET)
                    print(BLUE + "===========================================" + RESET + "\n")
                    print("\n" * 1)
                    break
                else:
                    print("kick out! The match continues!")
                    print(MAGENTA + "Bret Hart kicks out!" + RESET)
                    opponent_health = 30

        # Bret Hart's turn to attack
        if opponent_health > 0 and not opponent_dazed:
            opponent_move = random.choice(['punch', 'kick', 'body slam', 'sharpshooter'])
            if opponent_move == 'punch':
                if opponent_punches <= 0:
                    continue
                damage = random.randint(10, 20)
                print_slow(MAGENTA + "Bret Hart punches " + player_name + "!" + RESET + "\n")
                print_slow(player_name + " takes " + str(damage) + " damage." + RESET + "\n")
                player_health -= damage
                opponent_punches -= 1

            elif opponent_move == 'kick':
                if opponent_kicks <= 0:
                    continue
                damage = random.randint(15, 35)
                print_slow(MAGENTA + "Bret Hart kicks " + player_name + "!" + RESET + "\n")
                print_slow(player_name + " takes " + str(damage) + " damage." + RESET + "\n")
                player_health -= damage
                opponent_kicks -= 1

            elif opponent_move == 'body slam':
                if opponent_body_slams <= 0:
                    continue
                damage = random.randint(20, 50)
                print_slow(MAGENTA + "Bret Hart performs a body slam on " + player_name + "!" + RESET + "\n")
                print_slow(player_name + " takes " + str(damage) + " damage." + RESET + "\n")
                player_health -= damage
                opponent_body_slams -= 1

            elif opponent_move == 'sharpshooter':
                if opponent_health <= 30:
                    if opponent_sharpshooter <= 0:
                        continue
                    damage = random.randint(40, 60)
                    print_slow(YELLOW + "Bret Hart locks " + player_name + " in the Sharpshooter!" + RESET + "\n")
                    print_slow(player_name + " takes " + str(damage) + " damage from the Sharpshooter!" + RESET + "\n")
                    player_health -= damage
                    opponent_sharpshooter -= 1

        if player_health <= 0 or opponent_health <= 0:
            print("===========================================")
            if player_health <= 0 and opponent_health <= 0:
                print_slow("Both " + player_name + " and Bret Hart are down!" + RESET + "\n")
            else:
                time.sleep(1)
                print("1...")
                time.sleep(1)
                print("2...")
                time.sleep(1)
                if player_health <= 0:
                    if random.random() < (1 - opponent_health / 100.0):
                        print("3... The match is over!")
                        print_slow(MAGENTA + "Oh no! " + player_name + " has been pinned by Bret Hart!" + RESET + "\n")
                        print("\n" * 1)
                        print(BLUE + "===========================================")
                        print(BLUE + player_name + " loses the match!" + RESET)
                        print(BLUE + "===========================================" + RESET + "\n")
                        print("\n" * 1)
                    else:
                        print("kick out! The match continues!")
                        print(GREEN + player_name + " kicks out!" + RESET)
                        player_health = 30
                else:
                    print("3... The match is over!")
                    if random.random() < (1 - player_health / 100.0):
                        print_slow(GREEN + "Congratulations, " + player_name + "! You have pinned Bret Hart!" + RESET + "\n")
                        print("\n" * 1)
                        print(BLUE + "===========================================")
                        print(BLUE + player_name + " wins the match!" + RESET)
                        print(BLUE + "===========================================" + RESET + "\n")
                        print("\n" * 1)
                    else:
                        print("kick out! The match continues!")
                        print(MAGENTA + "Bret Hart kicks out!" + RESET)
                        opponent_health = 30

def print_slow(text):
    for char in text:
        sys.stdout.write(char)
        sys.stdout.flush()
        time.sleep(0.05)


wrestling_match()
